#include "nativeutils.h"


/*
  List creation helper funcs.  Example usage:

   l = create_empty_list();

   for (i = 0; i < 10; ++i) {
      struct descrip intval;
      MakeInt(i, &intval);
      c_put(&l, &intval);
   }
*/

struct descrip create_empty_list() {
   return create_list(0, NULL);
}

struct descrip create_list(int n, dptr d) {
   struct descrip res;

   struct b_list *hp;
   struct b_lelem *bp;
   word i, size;
   word nslots;
 
   nslots = size = n;
 
   if (nslots == 0)
      nslots = MinListSlots;
 
   /*
    * Allocate the list-header block and a list-element block.
    *  Note that nslots is the number of slots in the list-element
    *  block while size is the number of elements in the list.
    */
   hp = alclist(size);
   bp = alclstb(nslots, (word)0, size);

   hp->listhead = hp->listtail = (union block *) bp;
   bp->listprev = bp->listnext = (union block *) hp;
 
   /*
    * Initialize each slot.
    */
   for (i = 0; i < size; i++)
      bp->lslots[i] = *d;
 
   res.dword = D_List;
   res.vword.bptr = (union  block *)hp;

   return res;
}
